Bug 1715 - Large Performance Improvement for Command Line Clients
: Large Performance Improvement for Command Line Clients
Status: RESOLVED FIXED
: Java WS Core
globus_ogsi_core
: 3.2.0
: RS/6000 AIX
: P2 normal
: ---
Assigned To:
:
:
:
:
  Show dependency treegraph
 
Reported: 2004-04-23 15:23 by
Modified: 2004-05-28 15:48 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2004-04-23 15:23:24
Command line clients ordinarily launch a JVM to run the command. Initializing 
the JVM is expensive and time-consuming. Elapsed time can be improved by 25% 
and CPU time by almost 50% using the -Xquickstart java option in the script 
that launches the command. This option works with IBM JDK 1.3.1 and IBM JDK 
1.4.1. We tried it on the managed-job-globusrun command and the launch-uhe 
script and saw dramatic performance improvements. 

Here is an example of the syntax for specifying this option
eval java ${OPTIONS} ${DEF_OPTIONS} -classpath ${LOCALCLASSPATH} -Xquickstart ${
EXEC} ${CMDLINE}
------- Comment #1 From 2004-04-23 15:39:58 -------
This is an issue for the launcher template generation, not admin guide
documentation.  Reassigning to GT3 core.
------- Comment #2 From 2004-04-26 14:55:59 -------
PLEASE NOTE: Adding -Xquickstart to the launch script may cause the JVM to fail 
to initialize unless it is IBM JDK 1.3.1 or IBM JDK 1.4.1.  SUN JDK 1.4.2 
definitely fails initialization with this directive specified. We have no 
experience with additional vendor's JDK's.
------- Comment #3 From 2004-04-28 01:19:45 -------
Does setting the "IBM_JAVA_OPTIONS" environment variable to "-Xquickstart" work 
instead of passing that as a command line option? This would be a better 
solution as it would still work nicely with Sun and other JVMs.
------- Comment #4 From 2004-04-28 09:01:07 -------
Subject: Re:  Large Performance Improvement for Command Line Clients

I spoke to our java team and they believe it can be configured as an 
environment variable. Furthermore, they also think that the IBM JDK will 
ignore invalid environment variables if the specific version of java does 
not support a given option. They do not know how other vendor JVM's 
respond to invalid environment variables. 

I have not tested -Xquickstart as an environment variable. Where, in 
Globus Toolkit, do you specify the IBM_JAVA_OPTIONS?  If this is 
configurable (and not as part of a build script option) I might be able to 
test it for you.  I do not have the luxury of re-installing or rebuilding 
GT3 but could test this if I had only to modify a configuration file and 
restart.

Judi

Senior Technical Staff Member
WebSphere Application Server Performance 
Tieline 8-526-0941  Outside Line (919) 486-0941





bugzilla-daemon@mcs.anl.gov
04/28/2004 02:19 AM
Please respond to bugzilla
 
        To:     Judi Bank/Poughkeepsie/IBM@IBMUS
        cc: 
        Subject:        [Bug 1715] Large Performance Improvement for 
Command Line Clients


http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=1715

gawor@mcs.anl.gov changed:

           What    |Removed                     |Added
----------------------------------------------------------------------------
             Status|NEW                         |ASSIGNED



------- Additional Comments From gawor@mcs.anl.gov  2004-04-28 01:19 
-------
Does setting the "IBM_JAVA_OPTIONS" environment variable to "-Xquickstart" 
work 
instead of passing that as a command line option? This would be a better 
solution as it would still work nicely with Sun and other JVMs.
 



------- You are receiving this mail because: -------
You reported the bug, or are watching the reporter.


<br><font size=2 face="sans-serif">I spoke to our java team and they believe
it can be configured as an environment variable. Furthermore, they also
think that the IBM JDK will ignore invalid environment variables if the
specific version of java does not support a given option. They do not know
how other vendor JVM's respond to invalid environment variables. </font>
<br>
<br><font size=2 face="sans-serif">I have not tested -Xquickstart as an
environment variable. Where, in Globus Toolkit, do you specify the IBM_JAVA_OPTIONS?
&nbsp;If this is configurable (and not as part of a build script option)
I might be able to test it for you. &nbsp;I do not have the luxury of re-installing
or rebuilding GT3 but could test this if I had only to modify a configuration
file and restart.</font>
<br>
<br><font size=2 face="sans-serif">Judi</font>
<br><font size=2 face="sans-serif"><br>
Senior Technical Staff Member<br>
WebSphere Application Server Performance <br>
Tieline 8-526-0941 &nbsp;Outside Line (919) 486-0941<br>
</font>
<br>
<br>
<br>
<table width=100%>
<tr valign=top>
<td>
<td><font size=1 face="sans-serif"><b>bugzilla-daemon@mcs.anl.gov</b></font>
<p><font size=1 face="sans-serif">04/28/2004 02:19 AM</font>
<br><font size=1 face="sans-serif">Please respond to bugzilla</font>
<td><font size=1 face="Arial">&nbsp; &nbsp; &nbsp; &nbsp; </font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; To:
&nbsp; &nbsp; &nbsp; &nbsp;Judi Bank/Poughkeepsie/IBM@IBMUS</font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; cc:
&nbsp; &nbsp; &nbsp; &nbsp;</font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; Subject:
&nbsp; &nbsp; &nbsp; &nbsp;[Bug 1715] Large Performance Improvement
for Command Line Clients</font></table>
<br>
<br>
<br><font size=2><tt>http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=1715<br>
<br>
gawor@mcs.anl.gov changed:<br>
<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; What &nbsp; &nbsp;|Removed &nbsp; &nbsp;
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |Added<br>
----------------------------------------------------------------------------<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Status|NEW &nbsp; &nbsp; &nbsp;
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |ASSIGNED<br>
<br>
<br>
<br>
------- Additional Comments From gawor@mcs.anl.gov &nbsp;2004-04-28 01:19
-------<br>
Does setting the &quot;IBM_JAVA_OPTIONS&quot; environment variable to &quot;-Xquickstart&quot;
work <br>
instead of passing that as a command line option? This would be a better
<br>
solution as it would still work nicely with Sun and other JVMs.<br>
 <br>
<br>
<br>
<br>
------- You are receiving this mail because: -------<br>
You reported the bug, or are watching the reporter.<br>
</tt></font>
<br>
------- Comment #5 From 2004-04-28 12:41:23 -------
I don't think you need to modify anything for the test. Just need to set the 
env. variable before executing any of the command line scripts.
------- Comment #6 From 2004-04-29 17:28:20 -------
I updated the launcher scripts to set IBM_JAVA_OPTIONS env. variable. Committed 
the update to cvs (trunk).